; WHATVESA.ASM (0.2) - using FASM
;
; public domain, free for any use, nenies proprajho
;
; rugxulo AT gmail
;
; Last modified:  Tuesday June 12, 2007

format binary
org 100h
use16

BELL=7
SUCCESS=004Fh

Komenco:
  mov ax,4F00h
  mov di,VESA_buffer
  int 10h
  cmp ax,SUCCESS
  jnz @f
  mov bx,di
  cmp word [bx],'VE'
  jnz @f
  cmp word [bx+2],'SA'
  jnz @f
  push word [bx+6] word [bx+8]
  mov ax,word [bx+4]
  aad
  mov byte [VESA_version],al
  aam
  or ax,'00'
  xchg ah,al
  mov byte [bx+4],' '
  mov byte [bx+5],al
  mov byte [bx+6],'.'
  mov byte [bx+7],ah
  mov word [bx+8],' '
  mov si,bx
  call print
  pop word [bx+8] word [bx+6]
  lds si,[bx+6]
  call print
@@:
  mov ax,word [cs:VESA_version]
  int 21h

putc:
  push ax
  xchg dx,ax
  mov ah,2
  int 21h
  pop ax
  ret

print:
@@:
  lodsb
  test al,al
  jz short @f
  cmp al,BELL  ; skip ASCII bell (very annoying)
  jz @b
  call putc
  jmp short @b
@@:
  ret

VESA_version db 0,4Ch
VESA_buffer rb 256

; EOF
